/*
 * Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package org.apache.camel.kafkaconnector.splunksink;

import java.util.Map;
import javax.annotation.Generated;
import org.apache.camel.kafkaconnector.CamelSinkConnectorConfig;
import org.apache.kafka.common.config.ConfigDef;

@Generated("This class has been generated by camel-kafka-connector-generator-maven-plugin, remove this annotation to prevent it from being generated.")
public class CamelSplunksinkSinkConnectorConfig
        extends
            CamelSinkConnectorConfig {

    public static final String CAMEL_SINK_SPLUNKSINK_KAMELET_SERVER_HOSTNAME_CONF = "camel.kamelet.splunk-sink.serverHostname";
    public static final String CAMEL_SINK_SPLUNKSINK_KAMELET_SERVER_HOSTNAME_DOC = "The address of your Splunk server. Example: my_server_splunk.com";
    public static final String CAMEL_SINK_SPLUNKSINK_KAMELET_SERVER_HOSTNAME_DEFAULT = null;
    public static final String CAMEL_SINK_SPLUNKSINK_KAMELET_SERVER_PORT_CONF = "camel.kamelet.splunk-sink.serverPort";
    public static final String CAMEL_SINK_SPLUNKSINK_KAMELET_SERVER_PORT_DOC = "The address of your Splunk server.";
    public static final Integer CAMEL_SINK_SPLUNKSINK_KAMELET_SERVER_PORT_DEFAULT = 8089;
    public static final String CAMEL_SINK_SPLUNKSINK_KAMELET_USERNAME_CONF = "camel.kamelet.splunk-sink.username";
    public static final String CAMEL_SINK_SPLUNKSINK_KAMELET_USERNAME_DOC = "The username to authenticate to Splunk Server.";
    public static final String CAMEL_SINK_SPLUNKSINK_KAMELET_USERNAME_DEFAULT = null;
    public static final String CAMEL_SINK_SPLUNKSINK_KAMELET_PASSWORD_CONF = "camel.kamelet.splunk-sink.password";
    public static final String CAMEL_SINK_SPLUNKSINK_KAMELET_PASSWORD_DOC = "The password to authenticate to Splunk Server.";
    public static final String CAMEL_SINK_SPLUNKSINK_KAMELET_PASSWORD_DEFAULT = null;
    public static final String CAMEL_SINK_SPLUNKSINK_KAMELET_INDEX_CONF = "camel.kamelet.splunk-sink.index";
    public static final String CAMEL_SINK_SPLUNKSINK_KAMELET_INDEX_DOC = "Splunk index to write to.";
    public static final String CAMEL_SINK_SPLUNKSINK_KAMELET_INDEX_DEFAULT = null;
    public static final String CAMEL_SINK_SPLUNKSINK_KAMELET_PROTOCOL_CONF = "camel.kamelet.splunk-sink.protocol";
    public static final String CAMEL_SINK_SPLUNKSINK_KAMELET_PROTOCOL_DOC = "Connection Protocol to Splunk server.";
    public static final String CAMEL_SINK_SPLUNKSINK_KAMELET_PROTOCOL_DEFAULT = "https";
    public static final String CAMEL_SINK_SPLUNKSINK_KAMELET_SOURCE_CONF = "camel.kamelet.splunk-sink.source";
    public static final String CAMEL_SINK_SPLUNKSINK_KAMELET_SOURCE_DOC = "The source named field of the data.";
    public static final String CAMEL_SINK_SPLUNKSINK_KAMELET_SOURCE_DEFAULT = null;
    public static final String CAMEL_SINK_SPLUNKSINK_KAMELET_SOURCE_TYPE_CONF = "camel.kamelet.splunk-sink.sourceType";
    public static final String CAMEL_SINK_SPLUNKSINK_KAMELET_SOURCE_TYPE_DOC = "The source named field of the data.";
    public static final String CAMEL_SINK_SPLUNKSINK_KAMELET_SOURCE_TYPE_DEFAULT = null;
    public static final String CAMEL_SINK_SPLUNKSINK_KAMELET_APP_CONF = "camel.kamelet.splunk-sink.app";
    public static final String CAMEL_SINK_SPLUNKSINK_KAMELET_APP_DOC = "The app name in Splunk.";
    public static final String CAMEL_SINK_SPLUNKSINK_KAMELET_APP_DEFAULT = null;
    public static final String CAMEL_SINK_SPLUNKSINK_KAMELET_CONNECTION_TIMEOUT_CONF = "camel.kamelet.splunk-sink.connectionTimeout";
    public static final String CAMEL_SINK_SPLUNKSINK_KAMELET_CONNECTION_TIMEOUT_DOC = "Timeout in milliseconds when connecting to Splunk server";
    public static final Integer CAMEL_SINK_SPLUNKSINK_KAMELET_CONNECTION_TIMEOUT_DEFAULT = 5000;
    public static final String CAMEL_SINK_SPLUNKSINK_KAMELET_MODE_CONF = "camel.kamelet.splunk-sink.mode";
    public static final String CAMEL_SINK_SPLUNKSINK_KAMELET_MODE_DOC = "The mode to publish events to Splunk.";
    public static final String CAMEL_SINK_SPLUNKSINK_KAMELET_MODE_DEFAULT = "stream";

    public CamelSplunksinkSinkConnectorConfig(
            ConfigDef config,
            Map<String, String> parsedConfig) {
        super(config, parsedConfig);
    }

    public CamelSplunksinkSinkConnectorConfig(Map<String, String> parsedConfig) {
        this(conf(), parsedConfig);
    }

    public static ConfigDef conf() {
        ConfigDef conf = new ConfigDef(CamelSinkConnectorConfig.conf());
        conf.define(CAMEL_SINK_SPLUNKSINK_KAMELET_SERVER_HOSTNAME_CONF, ConfigDef.Type.STRING, CAMEL_SINK_SPLUNKSINK_KAMELET_SERVER_HOSTNAME_DEFAULT, ConfigDef.Importance.HIGH, CAMEL_SINK_SPLUNKSINK_KAMELET_SERVER_HOSTNAME_DOC);
        conf.define(CAMEL_SINK_SPLUNKSINK_KAMELET_SERVER_PORT_CONF, ConfigDef.Type.INT, CAMEL_SINK_SPLUNKSINK_KAMELET_SERVER_PORT_DEFAULT, ConfigDef.Importance.MEDIUM, CAMEL_SINK_SPLUNKSINK_KAMELET_SERVER_PORT_DOC);
        conf.define(CAMEL_SINK_SPLUNKSINK_KAMELET_USERNAME_CONF, ConfigDef.Type.STRING, CAMEL_SINK_SPLUNKSINK_KAMELET_USERNAME_DEFAULT, ConfigDef.Importance.HIGH, CAMEL_SINK_SPLUNKSINK_KAMELET_USERNAME_DOC);
        conf.define(CAMEL_SINK_SPLUNKSINK_KAMELET_PASSWORD_CONF, ConfigDef.Type.PASSWORD, CAMEL_SINK_SPLUNKSINK_KAMELET_PASSWORD_DEFAULT, ConfigDef.Importance.HIGH, CAMEL_SINK_SPLUNKSINK_KAMELET_PASSWORD_DOC);
        conf.define(CAMEL_SINK_SPLUNKSINK_KAMELET_INDEX_CONF, ConfigDef.Type.STRING, CAMEL_SINK_SPLUNKSINK_KAMELET_INDEX_DEFAULT, ConfigDef.Importance.MEDIUM, CAMEL_SINK_SPLUNKSINK_KAMELET_INDEX_DOC);
        conf.define(CAMEL_SINK_SPLUNKSINK_KAMELET_PROTOCOL_CONF, ConfigDef.Type.STRING, CAMEL_SINK_SPLUNKSINK_KAMELET_PROTOCOL_DEFAULT, ConfigDef.Importance.MEDIUM, CAMEL_SINK_SPLUNKSINK_KAMELET_PROTOCOL_DOC);
        conf.define(CAMEL_SINK_SPLUNKSINK_KAMELET_SOURCE_CONF, ConfigDef.Type.STRING, CAMEL_SINK_SPLUNKSINK_KAMELET_SOURCE_DEFAULT, ConfigDef.Importance.MEDIUM, CAMEL_SINK_SPLUNKSINK_KAMELET_SOURCE_DOC);
        conf.define(CAMEL_SINK_SPLUNKSINK_KAMELET_SOURCE_TYPE_CONF, ConfigDef.Type.STRING, CAMEL_SINK_SPLUNKSINK_KAMELET_SOURCE_TYPE_DEFAULT, ConfigDef.Importance.MEDIUM, CAMEL_SINK_SPLUNKSINK_KAMELET_SOURCE_TYPE_DOC);
        conf.define(CAMEL_SINK_SPLUNKSINK_KAMELET_APP_CONF, ConfigDef.Type.STRING, CAMEL_SINK_SPLUNKSINK_KAMELET_APP_DEFAULT, ConfigDef.Importance.MEDIUM, CAMEL_SINK_SPLUNKSINK_KAMELET_APP_DOC);
        conf.define(CAMEL_SINK_SPLUNKSINK_KAMELET_CONNECTION_TIMEOUT_CONF, ConfigDef.Type.INT, CAMEL_SINK_SPLUNKSINK_KAMELET_CONNECTION_TIMEOUT_DEFAULT, ConfigDef.Importance.MEDIUM, CAMEL_SINK_SPLUNKSINK_KAMELET_CONNECTION_TIMEOUT_DOC);
        conf.define(CAMEL_SINK_SPLUNKSINK_KAMELET_MODE_CONF, ConfigDef.Type.STRING, CAMEL_SINK_SPLUNKSINK_KAMELET_MODE_DEFAULT, ConfigDef.Importance.MEDIUM, CAMEL_SINK_SPLUNKSINK_KAMELET_MODE_DOC);
        return conf;
    }
}